/**** Automatic weather station 01A ****/
#define VERSION "0.1"
#define ID "$Id: irmrak4.c 2177 2011-09-05 18:56:16Z kaklik $"
#include "main.h"
#include <string.h>

#CASE    // Case sensitive compiler

#define LCD_ENABLE_PIN  PIN_E0                                    ////
#define LCD_RS_PIN      PIN_E1                                    ////
#define LCD_RW_PIN      PIN_E2                                    ////
#define LCD_DATA4       PIN_D4                                    ////
#define LCD_DATA5       PIN_D5                                    ////
#define LCD_DATA6       PIN_D6                                    ////
#define LCD_DATA7       PIN_D7 
#include <lcd.c>

#define  SEND_DELAY     50       // Time between two characters on RS232

char  VER[4]=VERSION;   // Buffer for concatenate of a version string

#define ONE_WIRE_PIN       PIN_C7
#include "..\ds1820.c"

void welcome(void)               // Welcome message
{
   char  REV[50]=ID;       // Buffer for concatenate of a version string

   if (REV[strlen(REV)-1]=='$') REV[strlen(REV)-1]=0;
   printf("\r\n\r\n# Mrakomer %s (C) 2011 UST\r\n",VER);   // Welcome message
   printf("#%s\r\n",&REV[4]);
//   printf("#\r\n");
//   printf("# commands: h, c, o, l, x, i, r, a, s, u\r\n");
//   printf("# h_eat, c_old, o_pen, l_ock, x_open, ");
//   printf("i_nfo, r_epeat, a_uto, s_single, u_pdate\r\n");
//   printf("#\r\n");
//   printf("# ver seq in[1/100 C] sky[1/100 C] sky[1/100 C] ");
//   printf("out[1/100 C] heat[s] dome[s] check\r\n\r\n");

//---WDT
   restart_wdt();
}

void main()
{
unsigned int16 seq=0;

   setup_adc_ports(NO_ANALOGS|VSS_VDD);
   setup_adc(ADC_CLOCK_DIV_2);
   setup_spi(SPI_SS_DISABLED);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_ccp1(CCP_OFF);
   setup_comparator(NC_NC_NC_NC);      // This device COMP currently not supported by the PICWizard
   setup_oscillator(OSC_8MHZ);


   printf("Simple Thermomether\r\n",);
   printf("(c) Kaklik 2013\r\n");
   printf("www.mlab.cz\r\n");

welcome();

/*   lcd_init();
   lcd_putc("(c) Kaklik 2013");
   lcd_gotoxy(3,2);
   lcd_putc("www.mlab.cz");
   Delay_ms(2000);
*/
   while (TRUE)
   {
     lcd_gotoxy(1,2);
//     printf(lcd_putc,"T: %f K  ",ds1820_read()+273.15);

//     printf("$T1.0 %f \r\n",ds1820_read()+273.15);
     delay_ms(100);
         { // printf
         char output[8];   // Output buffer
         int8 j;           // String pointer
         int8 check=0;     // Checksum is calculated between '$' and '*'

         delay_us(SEND_DELAY);
         putc('$');
         delay_us(SEND_DELAY);
         sprintf(output,"AWS%s \0",VER);
         j=0; while(output[j]!=0) { delay_us(SEND_DELAY); putc(output[j]); check^=output[j++]; }
         sprintf(output,"%Lu \0", seq);
         j=0; while(output[j]!=0) { delay_us(SEND_DELAY); putc(output[j]); check^=output[j++]; }
         sprintf(output,"%f \0", ds1820_read()+273.15);
         j=0; while(output[j]!=0) { delay_us(SEND_DELAY); putc(output[j]); check^=output[j++]; }
         sprintf(output,"*%X\r\n\0", check);
         j=0; while(output[j]!=0) { delay_us(SEND_DELAY); putc(output[j++]); }
         delay_us(SEND_DELAY);
      }
      
//---WDT
      restart_wdt();
            seq++;        // Increment the number of measurement

   }

}

//#include "dbloader.c" // Space reservation for the BootLoader
